mod Ex02b

incl Mtex

incl Maux

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-INF-465 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end piatok 25.2.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/1011ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované rekurzii s 
  mierou a definíciam predikátov. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming Summer 2010/11. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/0 Tex0_sigma0
  Subsup(Id(0,Ent('Sigma'),0),75,Num('0',0),None)

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Definitions of Predicates.  \end 

rem 
  \para \bf  Subsection. Explicit Definitions of Predicates.  \end 

rem 
  \para \bf  Bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para Atomic formulas: \ft x = y \end, \ft R(x) \end. 
   \item \para Propositional connectives: \ft \t \end, \ft \f \end, \ft ~R \end, 
         \ft R & Q \end, \ft R \/ Q \end, \ft R -> Q \end, \ft R <-> Q \end. 
   \item \para Bounded quantification: \ft \eb y y <= x: R \end, 
         \ft \ab y y <= x: R \end, \ft \eb y y < x: R \end, 
         \ft \ab y y < x: R \end. 
   \item \para Notational conventions: \ft x != y \end, \ft x <= y \end, 
         \ft x < y \end, \ft x > y \end, \ft x >= y \end. 
  \end
  \para \it  Remark.  \end Bounded quantifiers have greater precedence than 
  propositional connectives. For instance, following formulas are different 
  \eq* 
    \ab y y <= x: (R -> Q)
  \end
  \eq* 
    \ab y y <= x: R -> Q
  \end

rem 
  \para \bf  Explicit definitions of predicates with bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 Q  \end Examples: 
  \def 
    pred R 
    R(x) <-> \eb y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> \eb y y < x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y < x: Q(x,y)
  \end

rem 
  \para \bf  \ft Tex0_sigma0 \end-predicates.  \end 
  \ft Tex0_sigma0 \end-predicates are defined by bounded formulas in the 
  language of first-order arithmetic which includes decimal constants, addition, 
  multiplication, comparision predicates, and previously defined 
  \ft Tex0_sigma0 \end-predicates. 

rem 
  \para \bf  Divisibility.  \end Find a \ft Tex0_sigma0 \end-definition of the 
  divisibility predicate. 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> Poo

rem 
  \para \bf  Primes.  \end Show that the predicate \ft Prime(x) \end holding of 
  prime numbers is a \ft Tex0_sigma0 \end-predicate. 

pred Prime 
  Prime(x) <-> Poo

rem 
  \para \bf  Powers of two.  \end Show that the predicate 
  \eq* 
    Pow2(x) <-> \e n x = Exp(2,n)
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Pow2 
  Pow2(x) <-> Poo

rem 
  \para \bf  Powers of four.  \end Show that the predicate 
  \eq* 
    Pow4(x) <-> \e n x = Exp(4,n)
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Pow4 
  Pow4(x) <-> Poo

rem 
  \para \bf  Powers of a prime.  \end \header* pred/2 Power_of_the_prime  \end 
  Show that there is a binary \ft Tex0_sigma0 \end-predicate 
  \ft Power_of_the_prime(x,p) \end such that 
  \eq* 
    Prime(p) -> Power_of_the_prime(x,p) <-> \e n x = Exp(p,n)
  \end

pred/2 Power_of_the_prime 
  Power_of_the_prime(x,p) <-> Poo

rem 
  \para \bf  Powers of primes.  \end Show that the predicate 
  \eq* 
    Power_of_some_prime(x) <-> \e p(Prime(p) & \e n x = Exp(p,n))
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Power_of_some_prime 
  Power_of_some_prime(x) <-> Poo

